# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Provides/Requires filtering is different from rpm 4.9 onwards
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e' 2>/dev/null || echo 0)

Name:		perl-NetAddr-IP
Version:	4.079
Release:	2.%{__distinit}%{__distvers}
Summary:	Manages IPv4 and IPv6 addresses and subnets
# Lite/Util/Util.xs is GPLv2+
# Other files are (GPLv2+ or Artistic clarified)
License:	GPLv2+ and (GPLv2+ or Artistic clarified)
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/NetAddr-IP/
Source0:	http://search.cpan.org/CPAN/authors/id/M/MI/MIKER/NetAddr-IP-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Config)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(Pod::Text)
# Module Runtime
BuildRequires:	perl(AutoLoader)
BuildRequires:	perl(Carp)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Math::BigInt)
BuildRequires:	perl(overload)
BuildRequires:	perl(Socket)
BuildRequires:	perl(Socket6)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::More)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Math::BigInt)
Requires:	perl(Socket6)

# Don't "provide" private Perl libs or redundant unversioned provides
%global __provides_exclude ^(perl\\(NetAddr::IP(::(InetBase|Util(PP)?))?\\)$|Util\\.so)

%description
This module provides an object-oriented abstraction on top of IP addresses
or IP subnets, that allows for easy manipulations.

%prep
%setup -q -n NetAddr-IP-%{version}

# Remove redundant unversioned provide if we don't have rpm 4.9 or later
%if ! %{rpm49}
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Evx 'perl\(NetAddr::IP(::(InetBase|Util(PP)?))?\)'"
%global __perl_provides %{provfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license Artistic Copying
%else
%doc Artistic Copying
%endif
%doc About-NetAddr-IP.txt Changes TODO docs/rfc1884.txt
%{perl_vendorarch}/auto/NetAddr/
%{perl_vendorarch}/NetAddr/
%{_mandir}/man3/NetAddr::IP.3*
%{_mandir}/man3/NetAddr::IP::InetBase.3*
%{_mandir}/man3/NetAddr::IP::Lite.3*
%{_mandir}/man3/NetAddr::IP::Util.3*
%{_mandir}/man3/NetAddr::IP::UtilPP.3*

%changelog
* Sat Jul 30 2016 Paul Howarth <paul@city-fan.org> - 4.079-2
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find commands using -empty and -delete
- Prefer %%global over %%define

* Sun Mar 27 2016 Paul Howarth <paul@city-fan.org> - 4.079-1
- Update to 4.079
  - Correct non-suppression of leading zeros in certain instances of new_no use
  - Put in missing code to propagate NetAddr::IP::Lite :nofqdn to IP.pm
- Explicitly BR: perl-devel, needed for EXTERN.h

* Thu Aug 20 2015 Paul Howarth <paul@city-fan.org> - 4.078-1
- Update to 4.078
  - Fix typo in Util.pm 1.53 MakefilePL that caused failure to find compiler

* Fri Aug 14 2015 Paul Howarth <paul@city-fan.org> - 4.077-1
- Update to 4.077
  - Added method is_local() to Lite.pm
  - Fix Util/Makefile.PL to work around bug in Android's sh
  - Add method full6m()
  - Fix Util/Makefile.PL issue with clang compiler (CPAN RT#86831)
- Classify buildreqs by usage

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 4.075-3
- Use %%license where possible

* Thu Jun 12 2014 Paul Howarth <paul@city-fan.org> - 4.075-1
- Update to 4.075
  - Change input filter for resolvable hostnames to allow the underscore
    character

* Sat Apr  5 2014 Paul Howarth <paul@city-fan.org> - 4.073-1
- Update to 4.073
  - Add documentation about FQDN conversion and an option to disable
- Drop %%defattr, redundant since rpm 4.4

* Tue Jan 28 2014 Paul Howarth <paul@city-fan.org> - 4.072-1
- Update to 4.072
  - Modify Makefile.PL to bypass missing 'pod2text'
- BR: perl(Pod::Text) to ensure we get pod2text

* Tue Oct  1 2013 Paul Howarth <paul@city-fan.org> - 4.071-1
- Update to 4.071
  - Add method "canon"

* Fri Sep 13 2013 Paul Howarth <paul@city-fan.org> - 4.070-1
- Update to 4.070
  - Yet another documention error fixed
  - Add new6FFFF, RFC4291 compliant ipv4->ipV6 new in Lite.pm

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 4.069-2
- Perl 5.18 rebuild

* Sun May 26 2013 Paul Howarth <paul@city-fan.org> - 4.069-1
- Update to 4.069
  - Add proper pod encoding in Lite.pm
  - Changed Makefile.PL to check for config.h when building for XS with 'gcc',
    try building with 'cc', and check again; if config.h is not found, force
    Pure Perl mode
  - Kill XS in winduhs and Darwin, both of which misbehave when compiling XS
    code
- Drop UTF8 patch, no longer needed

* Wed Apr  3 2013 Paul Howarth <paul@city-fan.org> - 4.068-1
- Update to 4.068
  - Update Makefile.PL in Util.pm to better detect 'winduhs'

* Sun Mar 31 2013 Paul Howarth <paul@city-fan.org> - 4.067-1
- Update to 4.067
  - Improved diagnostic message for "die" with bad mask for hostenum,
    hostenumref, split, splitref, rsplit, rsplitref
- Include new docfile About-NetAddr-IP.txt
- Update UTF8 patch

* Tue Oct 30 2012 Paul Howarth <paul@city-fan.org> - 4.066-1
- Update to 4.066
  - Support bracketed IPv6 URI notation as described in RFC-3986

* Wed Oct  3 2012 Paul Howarth <paul@city-fan.org> - 4.065-1
- Update to 4.065
  - Correct format for IPv6 embedded IPv4 addresses (CPAN RT#79964)

* Thu Sep 27 2012 Paul Howarth <paul@city-fan.org> - 4.064-1
- Update to 4.064
  - Updated GPL v2.0 text and address in all modules
  - Added support for rfc3021 /31 networks to hostenum
- Update UTF8 patch

* Sat Jun 23 2012 Paul Howarth <paul@city-fan.org> - 4.062-2
- Perl 5.16 rebuild

* Thu Jun  7 2012 Paul Howarth <paul@city-fan.org> - 4.062-1
- Update to 4.062 (documentation updates)

* Wed May  9 2012 Paul Howarth <paul@city-fan.org> - 4.061-1
- Update to 4.061
  - Fix change in behavior introduced in v4.050 where an empty string supplied
    to "new" previously returned 'undef' and now returns 'default' for ipV4 or
    ipV6 (CPAN RT#75976)
  - Fixed bug in Lite.pm that returned $ip->num() = 2^128 for 0.0.0.0/0

* Thu Mar  8 2012 Paul Howarth <paul@city-fan.org> - 4.059-1
- Update to 4.059
  - Add is_rfc1918 to Lite.pm v1.42
  - Documentation updates
- License is GPLv2+ or Artistic, not just GPLv2+
- Recode NetAddr::IP::Lite module and manpage as UTF-8
- Don't need to remove empty directories from the buildroot
- Drop compatibility with distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Sat Nov 12 2011 Paul Howarth <paul@city-fan.org> - 4.058-1
- Update to 4.058
  - In Lite.pm v1.40:
    - Add call to InetBase::fillIPv4 to all uses of gethostbyname
  - In InetBase v0.06:
    - Break out the code that expands short IPv4 addresses into dotquad format
      to account for broken BSD implementations of inet_aton and gethostbyname
      that do not recognize the short format, and EXPORT this as sub 'fillIPv4'
  - In Util.pm v1.45:
    - Add 'fillIPv4' to calls to gethostbyname to work around broken inet_aton
      and gethostbyname implementations in certain BSD implementations

* Fri Nov  4 2011 Paul Howarth <paul@city-fan.org> - 4.056-1
- Update to 4.056
  - In InetBase.pm v0.04:
    - Improve inet_aton to overcome broken gethostbyname found in NetBSD and
      OpenBSD

* Fri Oct 28 2011 Paul Howarth <paul@city-fan.org> - 4.055-1
- Update to 4.055
  - In Lite.pm v1.38:
    - Remove Calc.pm
    - Add detection of early Math::BigInt object structure
    - Fix CPAN RT#71869 - a failed test routine, issues with Math::BigInt variants
- Drop patches added for 4.053; no longer needed

* Thu Oct 27 2011 Paul Howarth <paul@city-fan.org> - 4.053-1
- Update to 4.053
  - In Lite.pm v1.36:
    - Fix CPAN RT#71925, a sub-variant of CPAN RT#62521 that showed up only for
      short notation for IPv4, e.g. 127/n, 127.0/n, 127.0.0/n but not
      127.0.0.0/n
- Upstream no longer ships README so no need to fix its encoding
- Drop redundant buildreqs perl(Test::Pod) and perl(Pod::Coverage)
- Add patch to remove debugging code accidentally left in
- Add patch to revert breakage in t/bigint.t from 4.052 (CPAN RT#71925)

* Wed Oct 26 2011 Paul Howarth <paul@city-fan.org> - 4.052-1
- Update to 4.052
  - Add test in Lite.pm v1.35 for api-version of Math::BigInt to support
    versions earlier than 1.70, circa December 2003
- Drop version requirement for Math::BigInt dependencies

* Tue Oct 25 2011 Paul Howarth <paul@city-fan.org> - 4.051-1
- Update to 4.051
  - In Lite.pm v1.34:
    - use Math::BigInt::Calc for creating BigInt values and fall back to
      NetAddr::IP::Calc if Math::BigInt is not present (fixes CPAN RT#71869)
  - Remove reference to Config{osname} in InetBase.pm v0.03 (Util v1.43)
- BR: perl(Data::Dumper) and perl(Math::BigInt::Calc) ≥ 0.40 if available
- Add runtime dependency on perl(Math::BigInt) for performance and consistency

* Sat Oct 22 2011 Paul Howarth <paul@city-fan.org> - 4.050-1
- Update to 4.050
  - In InetBase.pm v0.02:
    - Socket6 prior to version 0.23 does not have AF_INET6 in the EXPORT_OK
      array; modify InetBase.pm v0.2 to work around this
  - Add support for Math::BigInt to NetAddr::IP::Lite v1.33
- Update UTF-8 patch to apply cleanly

* Thu Oct 20 2011 Paul Howarth <paul@city-fan.org> - 4.049-1
- Update to 4.049
  - In Lite v1.32:
    - Add capability to parse input of the form ->new6(12345,1); this should
      have been there but was missing (CPAN RT#68723)
  - In Util v1.41:
    - Add inet_pton, inet_ntop, AF_INET, AF_INET6
    - Modify inet_n2dx and inet_n2ad to recognize the new 128-bit IPv4 format
      ::FFFF:FFFF:0:0
    - replace isIPv4 with a pure perl version for portability
  - Split the following into NetAddr::IP::InetBase v0.01 to provide better
    long-term support for IPv6:
    - inet_aton
    - inet_ntoa
    - ipv6_aton
    - ipv6_n2x
    - ipv6_n2d
    - inet_any2n
    - inet_n2dx
    - inet_n2ad
    - inet_ntop
    - inet_pton
    - packzeros
    - isIPv4
    - isNewIPv4
    - isAnyIPv4
    - AF_INET
    - AF_INET6
- BR: perl(Carp)
- BR: perl(Socket6) for test suite
- Update UTF-8 patch to apply cleanly
- License is now GPL+ or Artistic in most of the code but Util.xs is GPLv2+ so
  we ship the whole thing under that license

* Sat Oct  8 2011 Paul Howarth <paul@city-fan.org> - 4.048-1
- Update to 4.048
  - Remove debug print statement from Util v1.40

* Fri Oct  7 2011 Paul Howarth <paul@city-fan.org> - 4.047-1
- Update to 4.047
  - Updated NetAddr::IP::Util to v1.39
  - Added isAnyIPv4, isNewIPv4, inet_4map6
  - Revised naip_gethostbyname to conform to Perl's gethostbyname output
  - Doc update only in Lite.pm v1.30

* Tue Jul  5 2011 Paul Howarth <paul@city-fan.org> - 4.044-2
- Rebuild for perl 5.14.1 in Rawhide
- Tweak provides filter to use rpm 4.9 native filtering mechanism
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu May 19 2011 Paul Howarth <paul@city-fan.org> - 4.044-1
- Update to 4.044
  - Added missing support for ->compactref(\@list), which is described in the
    documentation but not implemented

* Wed Apr  6 2011 Paul Howarth <paul@city-fan.org> - 4.043-1
- Update to 4.043
  - Update documentation on the use of "adding constants to an IP address"

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 4.042-1
- Update to 4.042
  - Update Lite.pm v1.27 to encompass treatment of /31 and /127
    point-to-point networks as described in RFC 3021; note that this changes
    the behaviour of the following methods for /31's and /127's:
    - first   returns the "network" address
    - last    returns the "broadcast" address
    - nth     index 0 returns "network" addr instead of undef
    - nth     index 1 returns "broadcast" addr instead of undef
    - num     returns 2 instead of 0 (zero)
    "old_nth" behaviour is unchanged
- Use a patch rather than a blind iconv to fix encodings
- Nobody else likes macros for commands

* Wed Mar  9 2011 Paul Howarth <paul@city-fan.org> - 4.041-1
- Update to 4.041
  - Updated Lite.pm "sub num" to support usable IP ranges greater than 2**32

* Sun Feb 20 2011 Paul Howarth <paul@city-fan.org> - 4.040-1
- Update to 4.040
  - Correction to use of Util.pm package lexicals

* Thu Feb 17 2011 Paul Howarth <paul@city-fan.org> - 4.039-1
- Update to 4.039
  - Correct documentation for 'split' methods

* Sun Dec 19 2010 Paul Howarth <paul@city-fan.org> - 4.038-1
- Update to 4.038
  - Modify subs "new" and "new6" in Lite.pm to accomodate Cisco mask syntax
    that uses space instead of "/" for a separator; this eliminates the need
    for "new_cis" and "newcis6", which are now deprecated
  - Modify Lite/t/v4-cnew.t and add Lite/t/v6-cnew.t to test the above

* Fri Nov 19 2010 Paul Howarth <paul@city-fan.org> - 4.037-1
- Update to 4.037
  - Add :upper and :lower to Lite.pm
  - Comment rfc5952 requirement for lowercase IPv6 notation in Lite.pm and IP.pm
  - Add test for :lower in Lite.pm

* Wed Nov 17 2010 Paul Howarth <paul@city-fan.org> - 4.036-1
- Update to 4.036
  - naip_gethostbyname modified to return undef instead of 0 (zero) on failure
  - Move sub's ipv6_n2d and ipv6_n2x to non-autosplit portion of module to
    eliminate warnings during autosplit of "our" variables
  - Update new6 to properly classify short ipv4 notation i.e. 127/8 with test
    for ":" rather than match for \d.\d.\d.\d (CPAN RT#62521)
  - Update t/v4-new.t for deprecated array syntax in perl 5.13
    was: qw(...stuff...)
    now: (qw(...stuff...))
- Patch for CPAN RT#62521 upstreamed

* Tue Nov  2 2010 Paul Howarth <paul@city-fan.org> - 4.035-2
- Apply further fix for new6 mask values for ipv4 addresses (CPAN RT#62521)

* Fri Oct 29 2010 Paul Howarth <paul@city-fan.org> - 4.035-1
- Update to 4.035
  - Fix bug in Lite v1.21 where new6 improperly assigns the mask value for an
    ipv4 address in 32-bit space instead of 128-bit space
  - Add new_cis and new_cis6 to Lite.pm v1.21 to accomodate Cisco syntax that
    has IP and MASK separated by a space
  - fix typo in documentation that left out example result

* Tue Oct 26 2010 Paul Howarth <paul@city-fan.org> - 4.034-1
- Update to 4.034 (updated Lite::_xnew v1.20 to properly handle ipV6 notation
  of the form xxxx:xxxx:xxxx:xxxx:xxxx:xxxx, DDD)

* Thu Sep 30 2010 Paul Howarth <paul@city-fan.org> - 4.033-1
- Update to 4.033 (conditionalize import of AF_INET6 in Util.pm and
  NetAddr::IP::UtilPolluted - CPAN RT#61742)

* Tue Sep 28 2010 Paul Howarth <paul@city-fan.org> - 4.032-1
- Update to 4.032 (added overload => 'ne' and '!=' to Lite.pm v1.18)

* Thu Jul 22 2010 Paul Howarth <paul@city-fan.org> - 4.030-1
- Update to 4.030 (resolve named hosts in Lite.pm using gethostbyname,
  followed by gethostbyname6 to determine whether to set ipV6 flag)

* Mon Jul 19 2010 Paul Howarth <paul@city-fan.org> - 4.029-1
- Update to 4.029 (in NetAddr::IP::Lite, add support for the sub "new" to
  resolve host6 names if the optional perl Socket6 module is available)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 4.028-2
- rebuild for perl 5.12.1 in Rawhide

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> - 4.028-1
- Update to 4.028 (fix some compiler issues)
- Use %%{?perl_default_filter} for provides filter
- Fix dist tag for RHEL-6 Beta

* Mon Feb  8 2010 Paul Howarth <paul@city-fan.org> - 4.027-2
- dist tag for Rawhide no longer needs special-casing

* Wed Jun 10 2009 Paul Howarth <paul@city-fan.org> - 4.027-1
- Update to 4.027 (build-time fix for systems with broken Archive::Tar)

* Mon Mar  9 2009 Paul Howarth <paul@city-fan.org> - 4.026-1
- Update to 4.026 (internal build tweaks)

* Mon Mar  2 2009 Paul Howarth <paul@city-fan.org> - 4.024-2
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Tue Jan 27 2009 Paul Howarth <paul@city-fan.org> - 4.024-1
- Update to 4.024

* Thu Jan 22 2009 Paul Howarth <paul@city-fan.org> - 4.023-1
- Update to 4.023
- Tweak dist tag macros to work on Rawhide with three-part releasenum

* Mon Dec 22 2008 Paul Howarth <paul@city-fan.org> - 4.022-1
- Update to 4.022

* Thu Dec 11 2008 Paul Howarth <paul@city-fan.org> - 4.021-1
- Update to 4.021
- Tidy up %%description

* Wed Dec 10 2008 Paul Howarth <paul@city-fan.org> - 4.020-1
- Update to 4.020

* Mon Dec  1 2008 Paul Howarth <paul@city-fan.org> - 4.019-1
- Update to 4.019

* Wed Nov  5 2008 Paul Howarth <paul@city-fan.org> - 4.015-1
- Update to 4.015

* Fri Oct 31 2008 Paul Howarth <paul@city-fan.org> - 4.013-1
- Update to 4.013
- Remove redundant unversioned provides

* Fri Oct 17 2008 Paul Howarth <paul@city-fan.org> - 4.012-1
- Update to 4.012

* Thu Oct 16 2008 Paul Howarth <paul@city-fan.org> - 4.011-1
- Import from Fedora
- Update to 4.011
- Add buildreqs perl(Pod::Coverage), perl(Test::Pod)

* Thu Aug  7 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 4.007-3
- Fix license tag

* Wed Mar  5 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 4.007-2
- Rebuild for new perl

* Tue Feb 12 2008 Andreas Thienemann <athienem@redhat.com> - 4.007-1
- Updated to 4.007
- Rebuilt against gcc-4.3

* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 4.004-4
- Rebuild for selinux ppc32 issue

* Tue Jul 10 2007 Andreas Thienemann <andreas@bawue.net> - 4.004-3
- Fixed missing BR on rawhide

* Thu Apr 26 2007 Andreas Thienemann <andreas@bawue.net> - 4.004-2
- Moar docs!

* Thu Apr 12 2007 Andreas Thienemann <andreas@bawue.net> - 4.004-1
- Specfile autogenerated by cpanspec 1.69.1
- Cleaned up for FE
